# Python related Problems

[[_TOC_]]

## Q: Installing Cartopy on Jet Cluster or any other module based environment?
[Cartopy Installation Notebook](QA-001-Cartopy-Installation-Jet.ipynb)

The user needs to load `geos` and `proj` libraries and install via 
`pip install --user cartopy` or create an anaconda environment and install there. 

*Installing from `conda-forge` is also possible, without loading any modules.* 
e.g. `conda install -c conda-forge cartopy` in a conda environment. 
This installs the libraries as well. (Not recommended)

## Q: Load Modules into the current Notebook Environment?
[Modules laoded in Kernel](QA-002-Modules-loaded-Kernel.ipynb)

The Idea is to create a `load_modules_into_jupyter.conf` file in your home directory asking for modules to be loaded when ther kernel is launched. 
*Please note that the file needs an empty line at the end*

## Q: How to create a user environment?
[Conda/Virtual Environment](QA-003-Conda-Environment.ipynb)

The idea is to install a conda or virtual environment and use that as a kernel for your notebooks. *Please note the solution for cartopy*

## Q: The Notebook server on the TeachingHub won't start?
[Teaching-Hub Spawn](QA-004-TeachingHub-SpawnFailed.md)

This usually happens because of an old configuration. Try to remove `~/.jupyter` on SRVX1.

## Q: Executing Python code on remote servers?
[Remote IPython Kernels](QA-005-Remote-Kernels.ipynb)

The idea is to launch an interactive IPython console on your computer (Linux or Mac, not sure about Windows) with a kernel on the server.

## Q: What Python IDE to use with remote kernels?
There are a lot of different ways to develop in python.
Some are:
 - [Visual Studio Code](https://code.visualstudio.com/)
 - [PyCharm](https://www.jetbrains.com/de-de/pycharm/)
 - Editors like Emacs, Sublime, Vim,...
 - Jupyter Notebooks and Lab e.g. on `Jupyterhub@srvx1` or `jupyterhub@jet`

 and `atom`. This is simple editor available on any platform and it can be extended with packages to become a full grown IDE with the power of open source. 
 [Atom-IDE-Install](QA-006-Atom-IDE.md)


## Q: How to add a new package to anaconda module?
[Add Package](QA-006-Add-Packages-to-Anaconda-Modules.ipynb)

It is relativly easy to install additional packages to a anaconda module distribution with `pip install --user`.
